QuickBars_ID = 20;

QuickBars_Options = {
    Show = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true},
    Lock = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false},
    Radial = {true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true},
    NSEW = {4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4},
    Scale = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
    Space = {36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36},
	Texture = {"Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_CriticalStrike.blp"}};

function QuickBars_Reset()
    QuickBars_Options.Show = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true};
    QuickBars_Options.Lock = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
    QuickBars_Options.Radial = {true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true};
    QuickBars_Options.NSEW = {4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
    QuickBars_Options.Scale = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    QuickBars_Options.Space = {36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36};
	QuickBars_Options.Texture = {"Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_CriticalStrike.blp"};
    
    for i=1, 20 do
        local Cur_Bar = getglobal("QuickBar"..string.format("%d", i));
        QuickBars_init(Cur_Bar);
    end
end

function QuickBars_CheckData()
    --Check if any options are missing, and if so recreate them
    if(QuickBars_Options.Show == NULL) then
        QuickBars_Options.Show = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true};
    end
    if(QuickBars_Options.Lock == NULL) then
        QuickBars_Options.Lock = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
    end
    if(QuickBars_Options.Radial == NULL) then
        QuickBars_Options.Radial = {true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true};
    end
    if(QuickBars_Options.NSEW == NULL) then
        QuickBars_Options.NSEW = {4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
    end
    if(QuickBars_Options.Scale == NULL) then
        QuickBars_Options.Scale = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    end
    if(QuickBars_Options.Space == NULL) then
        QuickBars_Options.Space = {36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36};
    end
    if(QuickBars_Options.Texture == NULL) then
        QuickBars_Options.Texture = {"Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_Druid_Cyclone.blp", "Interface/Icons/Ability_CriticalStrike.blp"};
    end
end
    
function QuickBarsPrintOptions(i)
   QuickBarsMessage("Printing bar "..string.format("%d",i));
    if(QuickBars_Options.Show[i]) then
      QuickBarsMessage("options.Show = true");
    else
      QuickBarsMessage("options.Show = false");
    end
    if(QuickBars_Options.Lock[i]) then
      QuickBarsMessage("options.Lock = true");
   else
      QuickBarsMessage("options.Lock = false");
    end
    if(QuickBars_Options.Radial[i]) then
      QuickBarsMessage("options.Radial = true");
   else
      QuickBarsMessage("options.Radial = false");
    end
   QuickBarsMessage("options.NSEW = "..string.format("%d", QuickBars_Options.NSEW[i]));
end

--Change the current quickbar selected to edit it's options
function QuickBars_Options_UpdateSelected(newID)
   QuickBars_ID = newID;
   QuickBars_Options_Frame_BarSelect_DropDown_CurrentBar:SetText(getglobal("QuickBars_BarSelectButton"..string.format("%d", newID)));
   QuickBars_Options_Frame_BarSelect_DropDown_BarList:Hide();
   QuickBars_Options_Init();
end
    
function QuickBarsMessage(msg)
   DEFAULT_CHAT_FRAME:AddMessage("[QuickBars] "..msg);
end

function QuickBars_Update(j)
    local NSEW = QuickBars_Options.NSEW[j];
    local bar = getglobal("QuickBar"..string.format("%d",j));
    local angle = 54;
    local xStep = -QuickBars_Options.Space[QuickBars_ID];
    local yStep = 0;

    if bar == nil then
	return;
    end
    
    getglobal(bar:GetName().."_Texture"):SetTexture(QuickBars_Options.Texture[j]);
    
    if (NSEW == 1) then
        angle = -QuickBars_Options.Space[QuickBars_ID];
        xStep = 0;
        yStep = QuickBars_Options.Space[QuickBars_ID];
    elseif (NSEW == 2) then
        angle = 144;
        xStep = 0;
        yStep = -QuickBars_Options.Space[QuickBars_ID];
    elseif (NSEW == 3) then
        angle = 234;
        xStep = QuickBars_Options.Space[QuickBars_ID];
        yStep = 0;
    end
    
    if (QuickBars_Options.Radial[j]) then
        for i=1, 6 do
            bar.Action_Button[i]:SetPoint("CENTER", bar, QuickBars_Options.Space[QuickBars_ID]*2*cos(angle+(36*i)), QuickBars_Options.Space[QuickBars_ID]*2*sin(angle+(36*i)));
        end
    else
        for i=1, 6 do
            bar.Action_Button[i]:SetPoint("CENTER", bar, xStep*i, yStep*i);
        end
    end
    
    --set scale
    bar:SetScale(QuickBars_Options.Scale[QuickBars_ID]);
    
    for i=1, 6 do
        bar.Action_Button[i]:Hide();
    end
end

function NSEW_OnClick(Direction)
   --NSEW => 1234
   if (Direction==1) then
      QuickBars_Options_Frame_North:SetChecked(1);
   else
      QuickBars_Options_Frame_North:SetChecked(0);
   end
   
   if (Direction==2) then
      QuickBars_Options_Frame_South:SetChecked(1);
   else
      QuickBars_Options_Frame_South:SetChecked(0);
   end
   
   if (Direction==3) then
      QuickBars_Options_Frame_East:SetChecked(1);
   else
      QuickBars_Options_Frame_East:SetChecked(0);
   end
   
   if (Direction==4) then
      QuickBars_Options_Frame_West:SetChecked(1);
   else
      QuickBars_Options_Frame_West:SetChecked(0);
   end
end

function QuickBars_Options_Init()
   --Set bar select colors
   for i=1, 20 do
      if (not QuickBars_Options.Show[i])  then
         getglobal("QuickBars".."_Options".."_Frame".."_BarSelect".."_DropDown".."_BarList".."_Bar"..string.format("%d",i).."_Text"):SetTextColor(1,0,0);
	  else
		 getglobal("QuickBars".."_Options".."_Frame".."_BarSelect".."_DropDown".."_BarList".."_Bar"..string.format("%d",i).."_Text"):SetTextColor(1,1,1);
	  end
   end
   
   --Set option buttons in main window
   QuickBars_Options_Frame_Show:SetChecked(QuickBars_Options.Show[QuickBars_ID]);
   QuickBars_Options_Frame_Lock:SetChecked(QuickBars_Options.Lock[QuickBars_ID]);
   QuickBars_Options_Frame_Radial:SetChecked(QuickBars_Options.Radial[QuickBars_ID]);
   NSEW_OnClick(QuickBars_Options.NSEW[QuickBars_ID]);
   
   QuickBars_Options_Frame_ScaleSlider:SetValue(string.format("%0.2f", QuickBars_Options.Scale[QuickBars_ID]));
   QuickBars_Options_Frame_SpaceSlider:SetValue(string.format("%0.2f", QuickBars_Options.Space[QuickBars_ID]));
   
   QuickBars_Options_Frame_TextureSelect_TextureBrowser:SetText(QuickBars_Options.Texture[QuickBars_ID]);
   QuickBars_Options_Frame_TextureSelect_Texture:SetTexture(QuickBars_Options.Texture[QuickBars_ID]);
end

function QuickBars_TextureClick(self)
	if(not (getglobal(self:GetName().."_TextureBrowser"):IsShown())) then
		getglobal(self:GetName().."_TextureBrowser"):Show();
	else
		local Texture = getglobal(self:GetName().."_TextureBrowser"):GetText();
		getglobal(self:GetName().."_TextureBrowser"):Hide();
		if (Texture == "") then
			QuickBars_Options.Texture[QuickBars_ID] = ("Interface\\Icons\\Ability_Druid_Cyclone.blp");
		else
			QuickBars_Options.Texture[QuickBars_ID] = Texture;
		end
		getglobal("QuickBar"..string.format("%d",QuickBars_ID).."_Texture"):SetTexture(QuickBars_Options.Texture[QuickBars_ID]);
		QuickBars_Options_Frame_TextureSelect_Texture:SetTexture(QuickBars_Options.Texture[QuickBars_ID]);
	end
end
